﻿var g_sAppPostName	= "ZonePlayerAPP";
var g_sAppScheme	= "ZonePlayerAPP";
var g_arBookmarks	= [];
var g_sMainColor    = ParseQueryString(window.location.href, "color", "1788da");

///////////////////////////////////////////////////////////////////////////////////////
function onZonePlayerAPP(sCmd, obj)
{
	if(sCmd=="GetBookMarkList")  {
		g_arBookmarks = obj.items;
		Bookmark_FillAllItems(false);
	}
	else if(sCmd=="AddBookMark") {
		var item = g_arBookmarks.find(function(ele) {
			return parseInt(ele.time) == parseInt(obj.items[0].time);
		});

		if ( item == null ){
			g_arBookmarks[g_arBookmarks.length] = obj.items[0];
			g_arBookmarks.sort(function(a, b)  {
				var atime = parseInt(a.time);
				var btime = parseInt(b.time);
				if(atime > btime)		return 1;
				if(atime == btime)		return 0;
				if(atime < btime)		return -1;
			});

			var nFindIndex = -1;
			var item = g_arBookmarks.find(function(ele, index) {
				if(parseInt(ele.time)==parseInt(obj.items[0].time)) { 
					nFindIndex = index;
					return true;
				}
				return false;
			});

			var arBookmarks = g_arBookmarks.filter(function(ele, index) {
				return index != parseInt(nFindIndex);
			});

			g_arBookmarks = arBookmarks;

			if(!confirm(PadStart("" + (nFindIndex + 1), 2, 0) + ".[" + SecondToHHMMSS(obj.items[0].time)+"] 북마크를 추가합니다.")) {
				return;
			}

			g_arBookmarks[g_arBookmarks.length] = obj.items[0];
			g_arBookmarks.sort(function(a, b)  {
				var atime = parseInt(a.time);
				var btime = parseInt(b.time);
				if(atime > btime)		return 1;
				if(atime == btime)		return 0;
				if(atime < btime)		return -1;
			});

			Bookmark_FillAllItems();
			document.getElementById("bookmarks").scrollLeft = document.getElementById("bookmarks").scrollLeft + $("#bookmark_" + nFindIndex).position().left;
		}
	}
	else if(sCmd=="GetIndexList")  {
		IndexList_FillAllItems(obj);
	}
}

///////////////////////////////////////////////////////////////////////////////////////
function GetBookMarkList()
{
    ZoneAppExecute("GetBookMarkList", "", "", false, true);
}

///////////////////////////////////////////////////////////////////////////////////////
function AddBookMark()
{
	ZoneAppExecute("AddBookMark", "", "", false, true);
}

///////////////////////////////////////////////////////////////////////////////////////
function DelBookMark(nIndex)
{
	if(!confirm(PadStart("" + (nIndex + 1), 2, 0) + ".[" + SecondToHHMMSS(g_arBookmarks[nIndex].time)+"] 북마크를 제거합니다.")) {
		return;
	}

	var arBookmarks = g_arBookmarks.filter(function(ele, index) {
		return index != parseInt(nIndex);
	});

	g_arBookmarks = arBookmarks;
	Bookmark_FillAllItems();

	if(nIndex>=0&&nIndex<g_arBookmarks.length) {
		document.getElementById("bookmarks").scrollLeft = document.getElementById("bookmarks").scrollLeft + $("#bookmark_" + nIndex).position().left;
	}
}

///////////////////////////////////////////////////////////////////////////////////////
function MovePlayTime(nTime)
{
	ZoneAppExecute("MovePlayTime", "time=" + nTime, "", false, true);
}

///////////////////////////////////////////////////////////////////////////////////////
function onBookmarkMovePlayTime(nTime)
{
	MovePlayTime(nTime);
}

///////////////////////////////////////////////////////////////////////////////////////
function onIndexListMovePlayTime(nTime, sURL)
{
	MovePlayTime(nTime);
	SendURL(sURL);
}

///////////////////////////////////////////////////////////////////////////////////////
function Close()
{
    ZoneAppExecute("Close", "", "", false, true);
}

///////////////////////////////////////////////////////////////////////////////////////
function SendURL(sURL)
{
	ZoneAppExecute("SendURL", "url=" + encodeURIComponent(sURL), "", false, true);
}

///////////////////////////////////////////////////////////////////////////////////////
function Bookmark_FillAllItems(bFireChangeBookMake)
{ 
	if ( typeof(bFireChangeBookMake) == "undefined" ) bFireChangeBookMake = true;
	$("#bookmarks").empty();
	
	g_arBookmarks.forEach(function(item, index) {
		Bookmark_FillItem(index, item, g_arBookmarks.length == (index + 1));
	});

	if(bFireChangeBookMake) {
		var sBookmarks = JSON.stringify(g_arBookmarks);
		var sParam  = "bookmarks=" + encodeURIComponent(sBookmarks);
		ZoneAppExecute("ChangeBookMark", sParam, "", false, true);
	}
}

function Bookmark_FillItem(nIndex, item, bLastItem)
{
	var sItem =
		'<div id=bookmark_' + nIndex + ' class="div-item" style="background-color: rgba(0, 0, 0, 0);width:160px;height:65px" >'
	+	'<table style="font-family:\'NotoSansKR-Medium\';font-size:10px; width:100%; height:100%; border:0px; padding:0px;" >'
	+		'<tr>'
	+			'<td width="20"></td>'
	+			'<td width="23" style="color: #' + g_sMainColor + ';text-align: left;" onclick="MovePlayTime(' + item.time + ')">'
	+			PadStart("" + (nIndex + 1), 2, 0)
	+			'</td>'
	+			'<td width="106" style="color: #ffffff;text-align: left;" onclick="MovePlayTime(' + item.time + ')">'
	+				SecondToHHMMSS(item.time)
	+			'</td>'
	+			'<td width="10">'
	+				'<img src="images/closeItem.png" width="20" height="20" style="position:relative;top:-10px;left:-8px" onclick="DelBookMark(' + nIndex + ')"></td>'
	+			'<td width="' + (bLastItem ? "0" : "1") + '">'
	+				'<div style="width:' + (bLastItem ? "0" : "1") + 'px;height:53px;background-color:#383838"></div>'
	+			'</td>'
	+		'</tr>'
	+	'</table>'
	+ '</div>';
	$("#bookmarks").append(sItem);
}

///////////////////////////////////////////////////////////////////////////////////////
function PadStart(src, len, padStr) {
    var retStr = "";
    var padCnt = Number(len) - String(src).length;
    if (Number(padCnt) < 1) {
    	return String(src).substring(0, Number(len));
    }
    for(var i=0;i<padCnt;i++) {
    	retStr += String(padStr);
    }
    return retStr+src;
}

///////////////////////////////////////////////////////////////////////////////////////
function SecondToHHMMSS(nSecond){ 
    nSecond = Number(nSecond);
    var h = Math.floor(nSecond / 3600);
    var m = Math.floor(nSecond % 3600 / 60);
    var s = Math.floor(nSecond % 3600 % 60);

    var hDisplay = h > 0 ? ((h < 10 ? "0" : "") + h + ":") : "00:";
	var mDisplay = (m < 10 ? "0" : "") + m + ":";
	var sDisplay = (s < 10 ? "0" : "") + s;
    return hDisplay + mDisplay + sDisplay; 
}

///////////////////////////////////////////////////////////////////////////////////////
function GetIndexList()
{
    ZoneAppExecute("GetIndexList", "", "", false, true);
}

///////////////////////////////////////////////////////////////////////////////////////
function IndexList_FillAllItems(obj)
{ 
	$("#indexlistTitle").html(obj.title)

	obj.items.forEach(function(item, index) {
		IndexList_FillItem(index, item, obj.items.length == (index + 1));
	});
}

function IndexList_FillItem(nIndex, item, bLastItem)
{
	var sItem =
	'<div id=indexlist_' + nIndex + ' class="div-item" style="background-color: rgba(0, 0, 0, 0);width:160px;height:165px;">'
	+ '<table style="font-family:\'NotoSansKR-Medium\';font-size:10px; width:100%; height:165px; border:0px; padding:0px;display:grid" onclick="onIndexListMovePlayTime(' + item.time + ', \'' + encodeURIComponent(item.url) + '\')">'
	+	'<tr style="height:60px;">'
	+	'<td width="20"></td>'
	+	'<td width="23" style="color: #' + g_sMainColor + ';text-align: left;">'
	+	PadStart("" + (nIndex + 1), 2, 0)
	+	'</td>'
	+	'<td width="106" style="color: #ffffff;text-align: left;">'
	+	SecondToHHMMSS(item.time)
	+	'</td>'
	+	'<td width="' + (bLastItem ? "0" : "1") + '" rowspan="2">'
	+	'	<div style="width:' + (bLastItem ? "0" : "1") + 'px;height:130px;background-color:#383838"></div>'
	+	'</td>'
	+	'</tr>'
	+	'<tr style="height:95px;">'
	+	'	<td width="20"></td>'
	+	'	<td width="23"></td>'
	+	'	<td width="106" style="color: #ffffff;">'
	+	'		<div style="color:#707070; position:relative;top:-16px; width:80px;height:90px;word-break:break-all; white-space: pre-wrap; overflow:clip">'
	+   item.title
	+	'</div></td></tr>'
	+	'</table>'
	+	'</div>';
	$("#indexlist").append(sItem);
}

///////////////////////////////////////////////////////////////////////////////////////
function ParseQueryString(sQueryString, sName, sDefaultValue)
{
	var arInfoSplit = sQueryString.split('?');
	if ( arInfoSplit.length == 2 )    
	{
		sQueryString = arInfoSplit[1];
	}

	//sQueryString = decodeURIComponent(sQueryString);
	var arItem = sQueryString.split('&');
	
	var sLower = "";
	sName = sName.toLowerCase() + "=";
	
	for ( var nF = 0 ; nF < arItem.length ; nF++ )
	{
		sLower = arItem[nF].toLowerCase();
		
		if ( sLower.indexOf(sName) == 0 )
		{ 
			if ( sLower.length == sName.length ) 
			{ 
				return sDefaultValue;
			}
			else
			{
				return decodeURIComponent(arItem[nF]).substr(sName.length, arItem[nF].length - sName.length);
			}
		}
	}

    return sDefaultValue;
}